(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/forms'), require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngtreegrid', ['exports', 'rxjs', '@angular/forms', '@angular/common', '@angular/core'], factory) :
    (factory((global.ngtreegrid = {}),global.rxjs,global.ng.forms,global.ng.common,global.ng.core));
}(this, (function (exports,rxjs,forms,common,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngtreegrid.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgtreegridService = /** @class */ (function () {
        function NgtreegridService() {
            this.display_data_observable = new rxjs.Subject();
            this.display_data_observable$ = this.display_data_observable.asObservable();
        }
        /**
         * @param {?} display_data
         * @return {?}
         */
        NgtreegridService.prototype.updateDisplayDataObservable = /**
         * @param {?} display_data
         * @return {?}
         */
            function (display_data) {
                this.display_data_observable.next(display_data);
            };
        /**
         * @param {?} value
         * @return {?}
         */
        NgtreegridService.prototype.isEmpty = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value === '' || value === undefined || value === 'undefined';
            };
        /**
         * @param {?} expand_tracker
         * @return {?}
         */
        NgtreegridService.prototype.expandAll = /**
         * @param {?} expand_tracker
         * @return {?}
         */
            function (expand_tracker) {
                for (var key in expand_tracker) {
                    if (expand_tracker.hasOwnProperty(key)) {
                        expand_tracker[key] = true;
                    }
                }
            };
        /**
         * @param {?} expand_tracker
         * @return {?}
         */
        NgtreegridService.prototype.collapseAll = /**
         * @param {?} expand_tracker
         * @return {?}
         */
            function (expand_tracker) {
                for (var key in expand_tracker) {
                    if (expand_tracker.hasOwnProperty(key)) {
                        expand_tracker[key] = false;
                    }
                }
                expand_tracker['data'] = true;
            };
        NgtreegridService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgtreegridService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgtreegridService.ngInjectableDef = i0.defineInjectable({ factory: function NgtreegridService_Factory() { return new NgtreegridService(); }, token: NgtreegridService, providedIn: "root" });
        return NgtreegridService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/store/store.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Store = /** @class */ (function () {
        function Store(ngTreeGridService) {
            this.ngTreeGridService = ngTreeGridService;
            this.processed_data = [];
            this.raw_data = [];
            this.group_keys = {}; // Contains all group keys.
            // Contains all group keys.
            this.processed_tree_data = {}; // Contains all group keys.
        }
        /**
         * @return {?}
         */
        Store.prototype.getRawData = /**
         * @return {?}
         */
            function () {
                return this.raw_data;
            };
        /**
         * @param {?} raw_data
         * @return {?}
         */
        Store.prototype.setRawData = /**
         * @param {?} raw_data
         * @return {?}
         */
            function (raw_data) {
                this.raw_data = raw_data;
            };
        /**
         * @param {?} processed_data
         * @return {?}
         */
        Store.prototype.getProcessedData = /**
         * @param {?} processed_data
         * @return {?}
         */
            function (processed_data) {
                return this.processed_data;
            };
        /**
         * @param {?} processed_data
         * @return {?}
         */
        Store.prototype.setProcessedData = /**
         * @param {?} processed_data
         * @return {?}
         */
            function (processed_data) {
                this.processed_data = processed_data;
                this.setDisplayData(__spread(processed_data));
            };
        /**
         * @return {?}
         */
        Store.prototype.getDisplayData = /**
         * @return {?}
         */
            function () {
                return this.display_data;
            };
        /**
         * @param {?} display_data
         * @return {?}
         */
        Store.prototype.setDisplayData = /**
         * @param {?} display_data
         * @return {?}
         */
            function (display_data) {
                this.display_data = display_data;
                this.ngTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        /**
         * @param {?} fields
         * @param {?} search_values
         * @return {?}
         */
        Store.prototype.filterBy = /**
         * @param {?} fields
         * @param {?} search_values
         * @return {?}
         */
            function (fields, search_values) {
                var _this = this;
                this.display_data = this.processed_data.filter(( /**
                 * @param {?} record
                 * @return {?}
                 */function (record) {
                    if (record.parent) {
                        return true;
                    }
                    /** @type {?} */
                    var found = true;
                    for (var index = 0; index < fields.length; index++) {
                        /** @type {?} */
                        var field_value = record[fields[index]];
                        /** @type {?} */
                        var search_value = search_values[index];
                        // If blank then continue.
                        if (!search_value) {
                            continue;
                        }
                        if (typeof (field_value) === 'number') {
                            if (field_value !== parseInt(search_value, 10)) {
                                found = false;
                            }
                        }
                        else {
                            /** @type {?} */
                            var column = _this.configs.columns[index];
                            if (!column.case_sensitive_filter) {
                                field_value = field_value.toLowerCase();
                                search_value = search_value.toLowerCase();
                            }
                            if (field_value.indexOf(search_value) === -1) {
                                found = false;
                            }
                        }
                    }
                    return found;
                }));
                this.ngTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        /**
         * @return {?}
         */
        Store.prototype.selectAll = /**
         * @return {?}
         */
            function () {
                this.display_data.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.row_selected = true;
                }));
            };
        /**
         * @return {?}
         */
        Store.prototype.deSelectAll = /**
         * @return {?}
         */
            function () {
                this.display_data.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.row_selected = false;
                }));
            };
        /**
      * Find path from root and assgn grouped data
      *
      * @param temp_traversed_paths It is the traversed path for the current group by key.
      * @param index Current index of the leaf node
      * @param group_by_data Generated group by data for the current leaf node
      */
        /**
         * Find path from root and assgn grouped data
         *
         * @param {?} temp_traversed_paths It is the traversed path for the current group by key.
         * @param {?} index Current index of the leaf node
         * @param {?} group_by_data Generated group by data for the current leaf node
         * @return {?}
         */
        Store.prototype.traverseRootData = /**
         * Find path from root and assgn grouped data
         *
         * @param {?} temp_traversed_paths It is the traversed path for the current group by key.
         * @param {?} index Current index of the leaf node
         * @param {?} group_by_data Generated group by data for the current leaf node
         * @return {?}
         */
            function (temp_traversed_paths, index, group_by_data) {
                /** @type {?} */
                var paths = temp_traversed_paths[index].split('.');
                /** @type {?} */
                var root_keys = this.processed_tree_data;
                for (var i = 0; i < paths.length - 1; i++) {
                    /** @type {?} */
                    var path = paths[i];
                    root_keys = root_keys[path];
                }
                // Set in last object to keep the reference.
                root_keys[paths[paths.length - 1]] = group_by_data;
            };
        /**
         * @param {?} data
         * @param {?} configs
         * @param {?} internal_configs
         * @param {?} edit_tracker
         * @param {?} expand_tracker
         * @return {?}
         */
        Store.prototype.groupData = /**
         * @param {?} data
         * @param {?} configs
         * @param {?} internal_configs
         * @param {?} edit_tracker
         * @param {?} expand_tracker
         * @return {?}
         */
            function (data, configs, internal_configs, edit_tracker, expand_tracker) {
                var _this = this;
                if (configs.sort_by && configs.sort_by.length > 0) {
                    data.sort(( /**
                     * @param {?} a
                     * @param {?} b
                     * @return {?}
                     */function (a, b) {
                        /** @type {?} */
                        var first = a[configs.sort_by];
                        /** @type {?} */
                        var second = b[configs.sort_by];
                        first = typeof first === 'string' ? first.toLowerCase().trim() : first;
                        second = typeof second === 'string' ? second.toLowerCase().trim() : second;
                        if (first < second) {
                            return -1;
                        }
                        else {
                            return 1;
                        }
                    }));
                }
                /** @type {?} */
                var group_by = configs.group_by;
                // It is an array of leaf nodes.
                /** @type {?} */
                var last_group_data = [data];
                // It represents the path to the leaf nodes.
                /** @type {?} */
                var traversed_paths = ['data'];
                this.processed_tree_data = { 'data': '' };
                group_by.forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    /** @type {?} */
                    var temp_traversed_paths = [];
                    /** @type {?} */
                    var temp_last_group_data = [];
                    /** @type {?} */
                    var group_keys = [];
                    var _loop_1 = function (index) {
                        /** @type {?} */
                        var group_data = last_group_data[index];
                        /** @type {?} */
                        var group_by_data = _this.groupByKey(group_data, key);
                        _this.traverseRootData(traversed_paths, index, group_by_data);
                        /** @type {?} */
                        var new_group_keys = Object.keys(group_by_data);
                        /** @type {?} */
                        var traversed_group_key = traversed_paths[index];
                        // Get list of grouped data for the current group by in an array.
                        new_group_keys.forEach(( /**
                         * @param {?} new_group_key
                         * @return {?}
                         */function (new_group_key) {
                            // Make keys separated by dots for all group by. Example 'data.book.type'
                            temp_traversed_paths.push(traversed_group_key + '.' + new_group_key);
                            temp_last_group_data.push(group_by_data[new_group_key]);
                        }));
                        group_keys.push.apply(group_keys, __spread(new_group_keys));
                    };
                    // Number of records in traversed_paths and last_group_data are same.
                    for (var index = 0; index < last_group_data.length; index++) {
                        _loop_1(index);
                    }
                    traversed_paths = temp_traversed_paths;
                    last_group_data = temp_last_group_data;
                    // Remove duplicates and blanks.
                    group_keys = group_keys.filter(( /**
                     * @param {?} item
                     * @param {?} pos
                     * @return {?}
                     */function (item, pos) {
                        return !_this.ngTreeGridService.isEmpty(item) && group_keys.indexOf(item) === pos;
                    }));
                    _this.group_keys[key] = group_keys;
                }));
                if (internal_configs.current_sorted_column) {
                    this.processData(internal_configs.current_sorted_column.sort_type, internal_configs.current_sorted_column.name, edit_tracker, expand_tracker);
                }
                else {
                    this.processData(null, null, edit_tracker, expand_tracker);
                }
                this.setRawData(data);
                this.configs = configs;
            };
        /**
         * @param {?} data
         * @param {?} group_by
         * @return {?}
         */
        Store.prototype.groupByKey = /**
         * @param {?} data
         * @param {?} group_by
         * @return {?}
         */
            function (data, group_by) {
                /** @type {?} */
                var group_by_data = {};
                // Make an array of group by key.
                data.forEach(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    /** @type {?} */
                    var key = '~' + item[group_by];
                    // Check if group by key is already an array or not.
                    if (!group_by_data[key]) {
                        group_by_data[key] = [];
                    }
                    group_by_data[key].push(item);
                }));
                return group_by_data;
            };
        /**
         * @param {?} sort_type
         * @param {?} sort_by
         * @param {?} edit_tracker
         * @param {?} expand_tracker
         * @return {?}
         */
        Store.prototype.processData = /**
         * @param {?} sort_type
         * @param {?} sort_by
         * @param {?} edit_tracker
         * @param {?} expand_tracker
         * @return {?}
         */
            function (sort_type, sort_by, edit_tracker, expand_tracker) {
                this.processed_data = [];
                /** @type {?} */
                var index = 0;
                // Make recursive call to generate records.
                this.generateData(sort_type, sort_by, this.processed_tree_data, 0, null, expand_tracker);
                this.processed_data.shift();
                // Add index to all records.
                this.processed_data.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.idx = index++;
                    edit_tracker[data.idx] = false;
                }));
                // Expand root so that first level shows up.
                expand_tracker['data'] = 1;
                this.setProcessedData(this.processed_data);
            };
        /**
         * @param {?} sort_type
         * @param {?} sort_by
         * @param {?} group_data
         * @param {?} level
         * @param {?} parent_key
         * @param {?} expand_tracker
         * @return {?}
         */
        Store.prototype.generateData = /**
         * @param {?} sort_type
         * @param {?} sort_by
         * @param {?} group_data
         * @param {?} level
         * @param {?} parent_key
         * @param {?} expand_tracker
         * @return {?}
         */
            function (sort_type, sort_by, group_data, level, parent_key, expand_tracker) {
                var _this = this;
                /** @type {?} */
                var group_keys = Object.keys(group_data);
                group_keys.forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    /** @type {?} */
                    var items = group_data[key];
                    /** @type {?} */
                    var composite_key = parent_key ? parent_key + '.' + key : key;
                    // If items is not an array then it has more group by arrays. So make recursive call.
                    if (!Array.isArray(items)) {
                        // Create an array of children ids.
                        /** @type {?} */
                        var children = Object.keys(items);
                        /** @type {?} */
                        var children_id_1 = [];
                        children.forEach(( /**
                         * @param {?} child
                         * @return {?}
                         */function (child) {
                            // Add child id to the composite key.
                            children_id_1.push(composite_key + '.' + child);
                        }));
                        _this.processed_data.push({
                            parent_id: parent_key,
                            node_id: composite_key,
                            node_text: key,
                            parent: true,
                            last_parent: false,
                            children: children_id_1,
                            level: level
                        });
                        expand_tracker[composite_key] = 0;
                        // Increase level to mark the level.
                        _this.generateData(sort_type, sort_by, items, level + 1, composite_key, expand_tracker);
                    }
                    else {
                        // Set Parent object.
                        _this.processed_data.push({
                            parent_id: parent_key,
                            node_id: composite_key,
                            node_text: key,
                            parent: true,
                            last_parent: true,
                            level: level
                        });
                        expand_tracker[composite_key] = 0;
                        // Sort Items
                        if (sort_type !== null) {
                            sort_type ? items.sort(( /**
                             * @param {?} a
                             * @param {?} b
                             * @return {?}
                             */function (a, b) { return (a[sort_by] > b[sort_by]) ? 1 : ((b[sort_by] > a[sort_by]) ? -1 : 0); })) :
                                items.sort(( /**
                                 * @param {?} a
                                 * @param {?} b
                                 * @return {?}
                                 */function (a, b) { return (a[sort_by] < b[sort_by]) ? 1 : ((b[sort_by] < a[sort_by]) ? -1 : 0); }));
                        }
                        // Set Child object.
                        items.forEach(( /**
                         * @param {?} item
                         * @return {?}
                         */function (item) {
                            item.parent = false;
                            item.parent_id = composite_key;
                            _this.processed_data.push(item);
                        }));
                    }
                }));
            };
        /**
         * @return {?}
         */
        Store.prototype.refreshDisplayData = /**
         * @return {?}
         */
            function () {
                this.display_data = this.processed_data;
                this.ngTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        return Store;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngtreegrid.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgtreegridComponent = /** @class */ (function () {
        function NgtreegridComponent(ngtreegridService) {
            this.ngtreegridService = ngtreegridService;
            this.expand_tracker = {}; // Track Expand or collapse.
            // Track Expand or collapse.
            this.columns = []; // Contains all column objects.
            // Contains all column objects.
            this.edit_tracker = {}; // Track Edit options.
            // Track Edit options.
            this.internal_configs = {
                show_add_row: false
            };
            this.default_configs = {
                css: {
                    expand_class: 'plus',
                    collapse_class: 'minus',
                    add_class: 'plus',
                    edit_class: '',
                    delete_class: '',
                    save_class: '',
                    cancel_class: '',
                    row_selection_class: 'selected',
                    header_class: '',
                    parent_class: 'parent',
                    row_filter_class: ''
                },
                actions: {
                    edit: false,
                    add: false,
                    delete: false,
                    resolve_edit: false,
                    resolve_add: false,
                    resolve_delete: false
                },
                data_loading_text: 'Loading...',
                group_by: [],
                group_by_header: [],
                action_column_width: '50px',
                filter: false,
                multi_select: false,
                group_by_width: [],
                multi_select_width: 'auto',
                row_class_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_edit_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_delete_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_select_function: ( /**
                 * @return {?}
                 */function () { return true; })
            };
            this.default_column_config = {
                sorted: 0,
                sort_type: null,
                editable: false,
                hidden: false,
                filter: true,
                case_sensitive_filter: false,
                sortable: true
            };
            this.store = new Store(this.ngtreegridService);
            this.expand = new i0.EventEmitter();
            this.collapse = new i0.EventEmitter();
            this.cellclick = new i0.EventEmitter();
            this.rowselect = new i0.EventEmitter();
            this.rowdeselect = new i0.EventEmitter();
            this.rowselectall = new i0.EventEmitter();
            this.rowdeselectall = new i0.EventEmitter();
            this.rowadd = new i0.EventEmitter();
            this.rowsave = new i0.EventEmitter();
            this.rowdelete = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.setDefaultConfigs();
                this.setColumnNames();
                // If there is no data then do nothing.
                if (!(this.data && this.data.length > 0)) {
                    window.console.warn('Data should not be empty!');
                    return;
                }
                this.store.groupData(this.data, this.configs, this.internal_configs, this.edit_tracker, this.expand_tracker);
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.setDefaultConfigs = /**
         * @return {?}
         */
            function () {
                this.store.processed_data = [];
                this.store.processed_tree_data = {};
                this.configs = Object.assign({}, this.default_configs, this.configs);
                // Deep clone.
                this.configs.actions = Object.assign({}, this.default_configs.actions, this.configs.actions);
                this.configs.css = Object.assign({}, this.default_configs.css, this.configs.css);
                if (!this.configs.group_by) {
                    window.console.error('group_by field is mandatory!');
                }
                else if (!Array.isArray(this.configs.group_by)) {
                    this.configs.group_by = [this.configs.group_by];
                }
                // Set default header for group_by field.
                if (!this.configs.group_by_header) {
                    this.configs.group_by_header = this.configs.group_by;
                }
                else {
                    if (!Array.isArray(this.configs.group_by_header)) {
                        this.configs.group_by_header = [this.configs.group_by_header];
                    }
                    if (this.configs.group_by_header.length !== this.configs.group_by.length) {
                        this.configs.group_by_header = this.configs.group_by;
                    }
                }
                // Set default width for group_by field.
                if (!this.configs.group_by_width) {
                    this.configs.group_by_width = this.configs.group_by.map(( /**
                     * @param {?} _
                     * @return {?}
                     */function (_) { return 'auto'; }));
                }
                else {
                    if (!Array.isArray(this.configs.group_by_width)) {
                        this.configs.group_by_width = [this.configs.group_by_width];
                    }
                    if (this.configs.group_by_width.length !== this.configs.group_by.length) {
                        this.configs.group_by_width = this.configs.group_by.map(( /**
                         * @param {?} _
                         * @return {?}
                         */function (_) { return 'auto'; }));
                    }
                }
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.setColumnNames = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns = this.configs.columns ? this.configs.columns : [];
                // If columns doesn't exist in user's object.
                if (!this.configs.columns) {
                    /** @type {?} */
                    var column_keys_1 = Object.keys(this.data[0]);
                    // Remove group by key.
                    this.configs.group_by.forEach(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        column_keys_1.splice(column_keys_1.indexOf(key), 1);
                    }));
                    // Insert Header and default configuration.
                    column_keys_1.forEach(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        _this.columns.push(Object.assign({ 'header': key, 'name': key }, _this.default_column_config));
                    }));
                }
                else {
                    // Insert Header and default configuration.
                    for (var i = 0; i < this.columns.length; i++) {
                        this.columns[i] = Object.assign({}, this.default_column_config, this.columns[i]);
                    }
                }
                if (!this.configs.group_by_column) {
                    this.configs.group_by_column = Object.assign({}, this.default_column_config);
                }
            };
        /**
         * @param {?} row
         * @return {?}
         */
        NgtreegridComponent.prototype.onExpandRow = /**
         * @param {?} row
         * @return {?}
         */
            function (row) {
                this.expand.emit(row);
            };
        /**
         * @param {?} rec
         * @return {?}
         */
        NgtreegridComponent.prototype.onCollapseRow = /**
         * @param {?} rec
         * @return {?}
         */
            function (rec) {
                this.collapse.emit(rec);
            };
        /**
         * @param {?} row
         * @return {?}
         */
        NgtreegridComponent.prototype.onRowSelect = /**
         * @param {?} row
         * @return {?}
         */
            function (row) {
                this.rowselect.emit(row);
            };
        /**
         * @param {?} column
         * @return {?}
         */
        NgtreegridComponent.prototype.sortColumn = /**
         * @param {?} column
         * @return {?}
         */
            function (column) {
                if (!column.sortable) {
                    return;
                }
                // If already sorted then reverse.
                column.sort_type = column.sorted ? !column.sort_type : 1;
                column.sorted = 1;
                this.internal_configs.current_sorted_column = column;
                // Sort array.
                this.store.processData(column.sort_type, column.name, this.edit_tracker, this.expand_tracker);
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.addRowToGrid = /**
         * @return {?}
         */
            function () {
                this.store.processed_tree_data = {};
                this.edit_tracker = {};
                this.store.groupData(this.data, this.configs, this.internal_configs, this.edit_tracker, this.expand_tracker);
            };
        /**
         * @param {?} rec
         * @return {?}
         */
        NgtreegridComponent.prototype.onRowAdd = /**
         * @param {?} rec
         * @return {?}
         */
            function (rec) {
                var _this = this;
                if (this.configs.actions.resolve_delete) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowadd.emit({
                            data: rec,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.addRowToGrid();
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.addRowToGrid();
                    this.rowadd.emit(rec);
                }
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.expandAll = /**
         * @return {?}
         */
            function () {
                this.ngtreegridService.expandAll(this.expand_tracker);
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.collapseAll = /**
         * @return {?}
         */
            function () {
                this.ngtreegridService.collapseAll(this.expand_tracker);
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.selectAll = /**
         * @return {?}
         */
            function () {
                this.store.selectAll();
                this.internal_configs.all_selected = true;
            };
        /**
         * @return {?}
         */
        NgtreegridComponent.prototype.deSelectAll = /**
         * @return {?}
         */
            function () {
                this.store.deSelectAll();
                this.internal_configs.all_selected = false;
            };
        NgtreegridComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-ngtreegrid',
                        template: "<table class=\"db-tree-grid\">\r\n    <thead db-tree-head\r\n      [columns]=\"columns\" \r\n      [configs]=\"configs\" \r\n      [internal_configs]=\"internal_configs\"\r\n      [store]=\"store\"\r\n      [rowselectall]=\"rowselectall\"\r\n      [rowdeselectall]=\"rowdeselectall\"\r\n      (sortcolumn)=\"sortColumn($event)\">\r\n    </thead>\r\n    \r\n    <tbody db-tree-body\r\n      [columns]=\"columns\" \r\n      [configs]=\"configs\" \r\n      [internal_configs]=\"internal_configs\"\r\n      [store]=\"store\"\r\n      [expand_tracker]=\"expand_tracker\" \r\n      [edit_tracker]=\"edit_tracker\"\r\n      [rowsave]=\"rowsave\"\r\n      [rowdelete]=\"rowdelete\"\r\n      [cellclick]=\"cellclick\"\r\n      (rowselect)=\"onRowSelect($event)\"\r\n      [rowdeselect]=\"rowdeselect\"\r\n      (rowexpand)=\"onExpandRow($event)\"\r\n      (rowcollapse)=\"onCollapseRow($event)\"\r\n      (rowadd)=\"onRowAdd($event)\">\r\n    </tbody>   \r\n    \r\n  </table>\r\n  ",
                        styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}"]
                    }] }
        ];
        /** @nocollapse */
        NgtreegridComponent.ctorParameters = function () {
            return [
                { type: NgtreegridService }
            ];
        };
        NgtreegridComponent.propDecorators = {
            expand: [{ type: i0.Output }],
            collapse: [{ type: i0.Output }],
            cellclick: [{ type: i0.Output }],
            rowselect: [{ type: i0.Output }],
            rowdeselect: [{ type: i0.Output }],
            rowselectall: [{ type: i0.Output }],
            rowdeselectall: [{ type: i0.Output }],
            rowadd: [{ type: i0.Output }],
            rowsave: [{ type: i0.Output }],
            rowdelete: [{ type: i0.Output }],
            data: [{ type: i0.Input }],
            configs: [{ type: i0.Input }]
        };
        return NgtreegridComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/body/components/tree-body/tree-body.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyComponent = /** @class */ (function () {
        function TreeBodyComponent() {
            this.loadingColspanCount = 0;
            this.rowadd = new i0.EventEmitter();
            this.rowexpand = new i0.EventEmitter();
            this.rowcollapse = new i0.EventEmitter();
            this.rowselect = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.loadingColspanCount = this.columns.length + 1;
                if (this.configs.multi_select) {
                    this.loadingColspanCount++;
                }
                if (this.configs.actions.edit || this.configs.actions.add || this.configs.actions.delete) {
                    this.loadingColspanCount++;
                }
            };
        /**
         * @param {?} traversed_paths
         * @return {?}
         */
        TreeBodyComponent.prototype.fetchTraversedPaths = /**
         * @param {?} traversed_paths
         * @return {?}
         */
            function (traversed_paths) {
                /** @type {?} */
                var paths = traversed_paths.split('.');
                /** @type {?} */
                var intermediate = this.store.processed_tree_data;
                for (var i = 0; i < paths.length; i++) {
                    /** @type {?} */
                    var path = paths[i];
                    intermediate = intermediate[path];
                }
                return intermediate;
            };
        /**
         * @param {?} id
         * @param {?} row
         * @return {?}
         */
        TreeBodyComponent.prototype.expandRow = /**
         * @param {?} id
         * @param {?} row
         * @return {?}
         */
            function (id, row) {
                var _this = this;
                this.expand_tracker[id] = 1;
                // If children is a parent and its value is empty then expand it automatically.
                row.children && row.children.forEach(( /**
                 * @param {?} child
                 * @return {?}
                 */function (child) {
                    /** @type {?} */
                    var ids = child.split('.');
                    /** @type {?} */
                    var last_child = ids[ids.length - 1];
                    // If empty!
                    if (_this.isEmpty(last_child)) {
                        _this.expand_tracker[child] = 1;
                    }
                }));
                this.rowexpand.emit(row);
            };
        /**
         * @param {?} id
         * @param {?} rec
         * @return {?}
         */
        TreeBodyComponent.prototype.collapseRow = /**
         * @param {?} id
         * @param {?} rec
         * @return {?}
         */
            function (id, rec) {
                var _this = this;
                this.expand_tracker[id] = 0;
                // Collapse all of its children.
                /** @type {?} */
                var keys = Object.keys(this.expand_tracker);
                keys.forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    if (key.indexOf(id) !== -1) {
                        _this.expand_tracker[key] = 0;
                    }
                }));
                this.rowcollapse.emit(rec);
            };
        /**
         * @param {?} value
         * @return {?}
         */
        TreeBodyComponent.prototype.isEmpty = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value === '' || value === undefined || value === 'undefined';
            };
        /**
         * @param {?} end
         * @return {?}
         */
        TreeBodyComponent.prototype.range = /**
         * @param {?} end
         * @return {?}
         */
            function (end) {
                /** @type {?} */
                var array = [];
                /** @type {?} */
                var current = 1;
                while (current < end) {
                    array.push(current);
                    current += 1;
                }
                return array;
            };
        /**
         * @param {?} row
         * @return {?}
         */
        TreeBodyComponent.prototype.rowAdd = /**
         * @param {?} row
         * @return {?}
         */
            function (row) {
                this.rowadd.emit(row);
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeBodyComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                var _this = this;
                /** @type {?} */
                var rec = $event.data;
                if (this.configs.actions.resolve_edit) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowsave.emit({
                            data: rec,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.edit_tracker[rec['idx']] = false;
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.edit_tracker[rec['idx']] = false;
                    this.rowsave.emit(rec);
                }
            };
        /**
         * @param {?} row_data
         * @return {?}
         */
        TreeBodyComponent.prototype.cancelEdit = /**
         * @param {?} row_data
         * @return {?}
         */
            function (row_data) {
                /** @type {?} */
                var index = row_data['idx'];
                this.edit_tracker[index] = false;
                // Cancel all changes ie copy from back up.
                Object.assign(row_data, this.internal_configs.current_edited_row);
            };
        /**
         * @param {?} data
         * @return {?}
         */
        TreeBodyComponent.prototype.prepareRowClass = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                /** @type {?} */
                var row_class = { 'child': !data.parent };
                row_class[this.configs.css.parent_class] = data.parent;
                row_class[this.configs.css.row_selection_class] = data.row_selected;
                return row_class;
            };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.selectRow = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
            function (row_data, event) {
                // Don't run if Multi select is enabled.
                if (this.configs.multi_select) {
                    return;
                }
                if (row_data.parent) {
                    return;
                }
                this.store.processed_data.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.row_selected = false;
                }));
                row_data.row_selected = true;
                this.rowselect.emit({ data: row_data, event: event });
            };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.selectRowOnCheck = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
            function (row_data, event) {
                if (!row_data.row_selected) {
                    row_data.row_selected = true;
                    this.rowselect.emit({ data: row_data, event: event });
                }
                else {
                    row_data.row_selected = false;
                    this.rowdeselect.emit({ data: row_data, event: event });
                }
                this.setSelectAllConfig();
            };
        /**
         * Set Select All config on Select change.
         *
         */
        /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        TreeBodyComponent.prototype.setSelectAllConfig = /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
            function () {
                /** @type {?} */
                var select_all = true;
                this.store.getDisplayData().forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    if (!data.row_selected) {
                        select_all = false;
                    }
                }));
                this.internal_configs.all_selected = select_all;
            };
        /**
         * @param {?} row_data
         * @return {?}
         */
        TreeBodyComponent.prototype.showSelectBox = /**
         * @param {?} row_data
         * @return {?}
         */
            function (row_data) {
                if (this.configs.row_select_function) {
                    return this.configs.row_select_function(row_data);
                }
                else {
                    return true;
                }
            };
        TreeBodyComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-body]',
                        template: "<tr *ngIf=\"store.raw_data.length==0\">\r\n  <td [innerHTML]=\"configs.data_loading_text\" [attr.colspan]=\"loadingColspanCount\" style=\"text-align: center\"></td>\r\n</tr>\r\n<tr db-filter-row [columns]=\"columns\" [configs]=\"configs\" [store]=\"store\" [internal_configs]=\"internal_configs\"\r\n  *ngIf=\"configs.filter\" [expand_tracker]=\"expand_tracker\" [ngClass]=\"configs.css.row_filter_class\">\r\n</tr>\r\n<tr db-add-row [columns]=\"columns\" [configs]=\"configs\" [internal_configs]=\"internal_configs\" [store]=\"store\"\r\n  (rowadd)=\"rowAdd($event)\" *ngIf=\"internal_configs.show_add_row\">\r\n</tr>\r\n\r\n<tr *ngFor=\"let data of store.display_data\" [ngClass]=\"prepareRowClass(data)\" [attr.id]=\"data['idx']\"\r\n  (click)=\"selectRow(data, $event)\" class=\"{{configs.row_class_function(data)}}\">\r\n\r\n  <!-- If parent text is empty then hide -->\r\n  <ng-container *ngIf=\"expand_tracker[data.parent_id] && data.parent && !isEmpty(data.node_text)\">\r\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\r\n      <!-- <input type=\"checkbox\" [checked]=\"data.row_selected\" (click)=\"selectRowOnCheck(data, $event)\"> -->\r\n    </td>\r\n    <td *ngIf=\"(configs.actions.edit || configs.actions.add || configs.actions.delete)\"></td>\r\n    <!-- Leave left td for down level parents -->\r\n    <td *ngFor=\"let level of range(data.level)\" class=\"clear-right-border clear-left-border\"></td>\r\n    <td *ngIf=\"!expand_tracker[data.node_id]\" [ngClass]=\"{\r\n          'clear-right-border': true, \r\n          'clear-left-border': (configs.actions.edit || configs.actions.add || configs.actions.delete)\r\n        }\">\r\n      <table class=\"expand-column-table\">\r\n        <tr>\r\n          <td>\r\n            <span (click)=\"expandRow(data.node_id, data)\" class=\"expand-icon-container\" title=\"Expand row\">\r\n              <i class=\"{{this.configs.css.expand_class}}\" aria-hidden=\"true\"></i>\r\n            </span>\r\n          </td>\r\n          <td>\r\n            <div class=\"parent-container\">\r\n              <db-tree-cell [cell_value]=\"data.node_text.replace('~', '')\" [row_data]=\"data\"\r\n                [column]=\"configs.group_by_column\">\r\n              </db-tree-cell>\r\n            </div>\r\n          </td>\r\n        </tr>\r\n      </table>\r\n    </td>\r\n    <td *ngIf=\"expand_tracker[data.node_id]\" [ngClass]=\"{\r\n          'clear-right-border': true, \r\n          'clear-left-border': (configs.actions.edit || configs.actions.add || configs.actions.delete)\r\n        }\">\r\n      <table class=\"expand-column-table\">\r\n        <tr>\r\n          <td>\r\n            <span (click)=\"collapseRow(data.node_id, data)\" class=\"expand-icon-container\" title=\"Collapse row\">\r\n              <i class=\"{{this.configs.css.collapse_class}}\" aria-hidden=\"true\"></i>\r\n            </span>\r\n          </td>\r\n          <td>\r\n            <div class=\"parent-container\">\r\n              <db-tree-cell [cell_value]=\"data.node_text\" [row_data]=\"data\" [column]=\"configs.group_by_column\">\r\n              </db-tree-cell>\r\n            </div>\r\n          </td>\r\n        </tr>\r\n      </table>\r\n    </td>\r\n    <!-- For parent levels add extra tds -->\r\n    <td *ngFor=\"let level of range(configs.group_by.length - data.level + 1)\"\r\n      class=\"clear-right-border clear-left-border\">\r\n    </td>\r\n    <td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\">\r\n      <ng-container *ngIf=\"column.group_aggregator && data.last_parent\">\r\n        <span [innerHTML]=\"column.group_aggregator(fetchTraversedPaths(data.node_id))\"></span>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"column.group_component && data.last_parent\">\r\n        <db-tree-cell [cell_value]=\"data\" [row_data]=\"fetchTraversedPaths(data.node_id)\"\r\n          [column]=\"column.group_component\">\r\n        </db-tree-cell>\r\n      </ng-container>\r\n    </td>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"expand_tracker[data.parent_id] && !data.parent\">\r\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\" (click)=\"selectRowOnCheck(data, $event)\">\r\n      <input type=\"checkbox\" [checked]=\"data.row_selected\" *ngIf=\"showSelectBox(data)\">\r\n    </td>\r\n    <td db-tree-cell-actions *ngIf=\"configs.actions.edit || configs.actions.delete || configs.actions.add\" [data]=\"data\"\r\n      [configs]=\"configs\" [store]=\"store\" [edit_tracker]=\"edit_tracker\" [rowdelete]=\"rowdelete\"\r\n      [internal_configs]=\"internal_configs\" (canceledit)=\"cancelEdit($event)\" (editcomplete)=\"saveRecord($event)\">\r\n    </td>\r\n    <td [ngClass]=\"{\r\n        'clear-right-border': true, \r\n        'clear-left-border': (configs.actions.edit || configs.actions.add || configs.actions.delete)\r\n      }\" *ngFor=\"let header of configs.group_by\">\r\n    </td>\r\n    <td class=\"clear-left-border\" *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\">\r\n      <db-tree-cell [cell_value]=\"data[column.name]\" [row_data]=\"data\" [column]=\"column\" [cellclick]=\"cellclick\"\r\n        [edit_on]=\"edit_tracker[data['idx']]\" (canceledit)=\"cancelEdit($event)\" (editcomplete)=\"saveRecord($event)\">\r\n      </db-tree-cell>\r\n    </td>\r\n  </ng-container>\r\n\r\n</tr>",
                        styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}select{padding:5px}tr.child{background:#fff}tr.parent{background:#fafbff}tr.selected{background-color:#e2e7eb}tr span.expand-icon-container{padding-right:10px;cursor:pointer}tr div.parent-container{display:inline-block}tr i.minus{border:1px solid transparent;margin-right:23px}tr i.minus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.checkbox_column{text-align:center}tr td:nth-child(1){padding:.3rem}tr td i.plus{border:1px solid transparent;margin-right:23px}tr td i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:2px;margin-left:14px}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}.column-hide{display:none}.expand-column-table td{border:none;padding:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        TreeBodyComponent.ctorParameters = function () { return []; };
        TreeBodyComponent.propDecorators = {
            store: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }],
            rowsave: [{ type: i0.Input }],
            rowdeselect: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            rowadd: [{ type: i0.Output }],
            rowexpand: [{ type: i0.Output }],
            rowcollapse: [{ type: i0.Output }],
            rowselect: [{ type: i0.Output }]
        };
        return TreeBodyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/components/tree-cell-view/default/tree-cell-view.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellViewComponent = /** @class */ (function () {
        function TreeCellViewComponent() {
            this.cellclick = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        TreeCellViewComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell-view',
                        template: "<div (click)=\"cellclick.emit($event)\">{{column.renderer ? column.renderer(cell_value, row_data) : cell_value}}</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        TreeCellViewComponent.ctorParameters = function () { return []; };
        TreeCellViewComponent.propDecorators = {
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }],
            cellclick: [{ type: i0.Output }]
        };
        return TreeCellViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/components/tree-cell-view/custom/custom-tree-cell.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellViewComponent = /** @class */ (function () {
        function CustomCellViewComponent(resolver) {
            this.resolver = resolver;
        }
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.column.component && !this.custom_component) {
                    this.createCustomComponent();
                    this.callOnComponentInit();
                }
            };
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.custom_component) {
                    this.custom_component.destroy();
                }
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var componentFactory = this.resolver.resolveComponentFactory(this.column.component);
                this.custom_component = this.custom_view.createComponent(componentFactory);
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
            function () {
                this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
                this.custom_component.instance.cell_value = this.cell_value;
                this.custom_component.instance.row_data = this.row_data;
            };
        CustomCellViewComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-custom-cell-component',
                        template: "\n      <ng-template #customView></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellViewComponent.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        CustomCellViewComponent.propDecorators = {
            column: [{ type: i0.Input }],
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            custom_view: [{ type: i0.ViewChild, args: ['customView', { read: i0.ViewContainerRef },] }]
        };
        return CustomCellViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/components/tree-cell-editor/default/default-editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DefaultEditor = /** @class */ (function () {
        function DefaultEditor() {
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
            this.cellclick = new i0.EventEmitter();
        }
        DefaultEditor.propDecorators = {
            canceledit: [{ type: i0.Output }],
            editcomplete: [{ type: i0.Output }],
            cellclick: [{ type: i0.Output }]
        };
        return DefaultEditor;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/components/tree-cell-editor/custom/custom-tree-cell-Editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellEditorComponent = /** @class */ (function (_super) {
        __extends(CustomCellEditorComponent, _super);
        function CustomCellEditorComponent(resolver) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            return _this;
        }
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.column.editor && !this.custom_component) {
                    this.createCustomComponent();
                    this.callOnComponentInit();
                }
            };
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.custom_component) {
                    this.custom_component.destroy();
                }
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var componentFactory = this.resolver.resolveComponentFactory(this.column.editor);
                this.custom_component = this.custom_view.createComponent(componentFactory);
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
                this.custom_component.instance.cell_value = this.cell_value;
                this.custom_component.instance.row_data = this.row_data;
                this.custom_component.instance.column = this.column;
                this.custom_component.instance.editcomplete.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.editcomplete.emit(event); }));
                this.custom_component.instance.canceledit.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.canceledit.emit(event); }));
                this.custom_component.instance.cellclick.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.cellclick.emit(event); }));
            };
        CustomCellEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-custom-cell-editor-component',
                        template: "\n      <ng-template #customView></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellEditorComponent.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        CustomCellEditorComponent.propDecorators = {
            column: [{ type: i0.Input }],
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            custom_view: [{ type: i0.ViewChild, args: ['customView', { read: i0.ViewContainerRef },] }]
        };
        return CustomCellEditorComponent;
    }(DefaultEditor));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/components/tree-cell-editor/default/cell-editor/tree-cell-editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellEditorComponent = /** @class */ (function (_super) {
        __extends(TreeCellEditorComponent, _super);
        function TreeCellEditorComponent() {
            return _super.call(this) || this;
        }
        /**
         * @return {?}
         */
        TreeCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        TreeCellEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell-editor',
                        template: "<input type=\"text\" \r\n    [(ngModel)]=\"row_data[column.name]\" \r\n    class=\"cell-default\" \r\n    (click)=\"cellclick.emit($event)\"\r\n    (keydown.enter)=\"editcomplete.emit($event)\"\r\n    (keydown.esc)=\"canceledit.emit()\"\r\n    >",
                        styles: ["input.cell-default{padding:5px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellEditorComponent.ctorParameters = function () { return []; };
        TreeCellEditorComponent.propDecorators = {
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }]
        };
        return TreeCellEditorComponent;
    }(DefaultEditor));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/components/tree-cell-actions/tree-cell-actions.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellActionsComponent = /** @class */ (function () {
        function TreeCellActionsComponent() {
            this.editcomplete = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellActionsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} row_data
         * @return {?}
         */
        TreeCellActionsComponent.prototype.enableEdit = /**
         * @param {?} row_data
         * @return {?}
         */
            function (row_data) {
                /** @type {?} */
                var index = row_data['idx'];
                this.edit_tracker[index] = true;
                this.internal_configs.current_edited_row = __assign({}, row_data);
            };
        /**
         * @param {?} idx
         * @return {?}
         */
        TreeCellActionsComponent.prototype.findRecordIndex = /**
         * @param {?} idx
         * @return {?}
         */
            function (idx) {
                for (var index = 0; index < this.store.processed_data.length; index++) {
                    if (this.store.processed_data[index].idx === idx) {
                        return index;
                    }
                }
            };
        /**
         * @param {?} rec
         * @return {?}
         */
        TreeCellActionsComponent.prototype.deleteRecord = /**
         * @param {?} rec
         * @return {?}
         */
            function (rec) {
                var _this = this;
                if (this.configs.actions.resolve_delete) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowdelete.emit({
                            data: rec,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.store.processed_data.splice(_this.findRecordIndex(rec.idx), 1);
                        _this.store.refreshDisplayData();
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.store.processed_data.splice(this.findRecordIndex(rec.idx), 1);
                    this.store.refreshDisplayData();
                    this.rowdelete.emit(rec);
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellActionsComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.editcomplete.emit({ event: $event, data: this.data });
            };
        TreeCellActionsComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-cell-actions]',
                        template: "<ng-container *ngIf=\"configs.actions.edit && configs.row_edit_function(data)\">\r\n  <div *ngIf=\"!edit_tracker[data['idx']]\" class=\"icon-container\">\r\n    <i (click)=\"enableEdit(data)\" *ngIf=\"configs.css.edit_class\" title=\"Edit row\" class=\"{{this.configs.css.edit_class}}\" aria-hidden=\"true\" ></i>\r\n    <svg (click)=\"enableEdit(data)\" *ngIf=\"!configs.css.edit_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Edit row</title><g data-name=\"Layer 2\"><g data-name=\"edit\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M19.4 7.34L16.66 4.6A2 2 0 0 0 14 4.53l-9 9a2 2 0 0 0-.57 1.21L4 18.91a1 1 0 0 0 .29.8A1 1 0 0 0 5 20h.09l4.17-.38a2 2 0 0 0 1.21-.57l9-9a1.92 1.92 0 0 0-.07-2.71zM9.08 17.62l-3 .28.27-3L12 9.32l2.7 2.7zM16 10.68L13.32 8l1.95-2L18 8.73z\"/></g></g></svg>             \r\n  </div>\r\n  <ng-container *ngIf=\"edit_tracker[data['idx']]\">\r\n    <div class=\"icon-container\">\r\n      <i (click)=\"saveRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\r\n      <svg (click)=\"saveRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\r\n    </div>\r\n    <div class=\"icon-container\">\r\n      <i (click)=\"canceledit.emit(data)\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\r\n      <svg (click)=\"canceledit.emit(data)\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\r\n    </div>\r\n  </ng-container>\r\n</ng-container>            \r\n<div *ngIf=\"configs.actions.delete && !edit_tracker[data['idx']] && configs.row_delete_function(data)\" class=\"icon-container\">\r\n  <i *ngIf=\"configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(data)\" class=\"{{this.configs.css.delete_class}}\" aria-hidden=\"true\"></i>\r\n  <svg *ngIf=\"!configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(data)\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Delete row</title><g data-name=\"Layer 2\"><g data-name=\"trash-2\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M21 6h-5V4.33A2.42 2.42 0 0 0 13.5 2h-3A2.42 2.42 0 0 0 8 4.33V6H3a1 1 0 0 0 0 2h1v11a3 3 0 0 0 3 3h10a3 3 0 0 0 3-3V8h1a1 1 0 0 0 0-2zM10 4.33c0-.16.21-.33.5-.33h3c.29 0 .5.17.5.33V6h-4zM18 19a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1V8h12z\"/><path d=\"M9 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/><path d=\"M15 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/></g></g></svg>            \r\n</div>",
                        styles: ["svg{width:25px;padding-right:4px}div.icon-container{display:inline-block;width:50%;text-align:center;color:#000;cursor:pointer}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellActionsComponent.ctorParameters = function () { return []; };
        TreeCellActionsComponent.propDecorators = {
            store: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }],
            data: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            editcomplete: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }]
        };
        return TreeCellActionsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/tree-cell.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellComponent = /** @class */ (function () {
        function TreeCellComponent() {
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} rec
         * @param {?} column
         * @return {?}
         */
        TreeCellComponent.prototype.onCellClick = /**
         * @param {?} rec
         * @param {?} column
         * @return {?}
         */
            function (rec, column) {
                this.cellclick.emit({ row: rec, column: column });
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellComponent.prototype.onEditComplete = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.editcomplete.emit({ event: $event, data: this.row_data });
            };
        TreeCellComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell',
                        template: "<ng-container>\r\n    <div [ngSwitch]=\"column.type\" *ngIf=\"!edit_on || !column.editable\">\r\n        <db-custom-cell-component \r\n            *ngSwitchCase=\"'custom'\" \r\n            [cell_value]=\"cell_value\" \r\n            [column]=\"column\" \r\n            [row_data]=\"row_data\" \r\n            (click)=\"onCellClick(row_data, column)\">\r\n        </db-custom-cell-component>\r\n        <db-tree-cell-view \r\n            *ngSwitchDefault \r\n            (cellclick)=\"onCellClick(row_data, column)\"\r\n            [cell_value]=\"cell_value\" \r\n            [column]=\"column\" \r\n            [row_data]=\"row_data\">\r\n        </db-tree-cell-view>\r\n    </div>\r\n    <div *ngIf=\"edit_on && column.editable\">\r\n        <db-custom-cell-editor-component \r\n            *ngIf=\"column.editor\" \r\n            [cell_value]=\"cell_value\" \r\n            [column]=\"column\" \r\n            [row_data]=\"row_data\"\r\n            (canceledit)=\"canceledit.emit(row_data['idx'])\"\r\n            (editcomplete)=\"onEditComplete($event)\">\r\n        </db-custom-cell-editor-component>\r\n        <db-tree-cell-editor \r\n            *ngIf=\"!column.editor\"\r\n            [cell_value]=\"cell_value\" \r\n            [row_data]=\"row_data\" \r\n            [column]=\"column\"\r\n            (canceledit)=\"canceledit.emit(row_data['idx'])\"\r\n            (editcomplete)=\"onEditComplete($event)\"\r\n            >\r\n        </db-tree-cell-editor>\r\n    </div>\r\n</ng-container>\r\n"
                    }] }
        ];
        /** @nocollapse */
        TreeCellComponent.ctorParameters = function () { return []; };
        TreeCellComponent.propDecorators = {
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }],
            edit_on: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            canceledit: [{ type: i0.Output }],
            editcomplete: [{ type: i0.Output }]
        };
        return TreeCellComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/cell/cell.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CellModule = /** @class */ (function () {
        function CellModule() {
        }
        CellModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            TreeCellComponent,
                            TreeCellViewComponent,
                            CustomCellViewComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent,
                            TreeCellActionsComponent
                        ],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule
                        ],
                        exports: [
                            TreeCellComponent,
                            CustomCellViewComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent,
                            TreeCellActionsComponent
                        ]
                    },] }
        ];
        return CellModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/body/components/add-row/add-row.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddRowComponent = /** @class */ (function () {
        function AddRowComponent() {
            this.row_data = {};
            this.rowadd = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        AddRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns.forEach(( /**
                 * @param {?} column
                 * @return {?}
                 */function (column) {
                    _this.row_data[column.name] = '';
                }));
            };
        /**
         * @param {?} e
         * @return {?}
         */
        AddRowComponent.prototype.saveAddRecord = /**
         * @param {?} e
         * @return {?}
         */
            function (e) {
                var _this = this;
                // const add_column = {};
                /** @type {?} */
                var index = this.store.processed_data.length;
                // this.columns.forEach(column => {
                //   if (column.editable) {
                //     add_column[column.name] = (document.getElementById(index + column.name) as HTMLInputElement).value;
                //   } else {
                //     add_column[column.name] = '';
                //   }
                // });
                this.configs.group_by.forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    _this.row_data[key] = (( /** @type {?} */(document.getElementById(index + key)))).value;
                }));
                this.store.raw_data.push(this.row_data);
                this.internal_configs.show_add_row = false;
                this.rowadd.emit(this.row_data);
            };
        /**
         * @return {?}
         */
        AddRowComponent.prototype.cancelAddEdit = /**
         * @return {?}
         */
            function () {
                this.internal_configs.show_add_row = false;
            };
        AddRowComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-add-row]',
                        template: "<td *ngIf=\"configs.multi_select\"></td>\r\n<td>\r\n  <div class=\"icon-container\">\r\n    <i (click)=\"saveAddRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\r\n    <svg (click)=\"saveAddRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\r\n  </div>\r\n  <div class=\"icon-container\">\r\n    <i (click)=\"cancelAddEdit()\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\r\n    <svg (click)=\"cancelAddEdit()\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\r\n  </div>\r\n</td>\r\n<td *ngFor=\"let group_by of configs.group_by\">\r\n  <select [attr.id]=\"store.processed_data.length+group_by\">\r\n    <option *ngFor=\"let key of store.group_keys[group_by]\">\r\n    {{key}}\r\n    </option>\r\n  </select>\r\n</td>\r\n<td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" >\r\n  <div *ngIf=\"column.editable\">\r\n    <db-custom-cell-editor-component \r\n        *ngIf=\"column.editor\"\r\n        [cell_value]=\"\" \r\n        [column]=\"column\" \r\n        [row_data]=\"row_data\"\r\n        (canceledit)=\"cancelAddEdit()\"\r\n        (editcomplete)=\"saveAddRecord($event)\">\r\n    </db-custom-cell-editor-component>\r\n    <db-tree-cell-editor \r\n        *ngIf=\"!column.editor\"\r\n        [cell_value]=\"\" \r\n        [row_data]=\"row_data\" \r\n        [column]=\"column\"\r\n        (canceledit)=\"cancelAddEdit()\"\r\n        (editcomplete)=\"saveAddRecord($event)\"\r\n        >\r\n    </db-tree-cell-editor>\r\n  </div>\r\n</td>",
                        encapsulation: i0.ViewEncapsulation.None,
                        styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}select{padding:5px}tr.child{background:#fff}tr.parent{background:#fafbff}tr.selected{background-color:#e2e7eb}tr span.expand-icon-container{padding-right:10px;cursor:pointer}tr div.parent-container{display:inline-block}tr i.minus{border:1px solid transparent;margin-right:23px}tr i.minus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.checkbox_column{text-align:center}tr td:nth-child(1){padding:.3rem}tr td i.plus{border:1px solid transparent;margin-right:23px}tr td i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:2px;margin-left:14px}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}.column-hide{display:none}.expand-column-table td{border:none;padding:0!important}svg{width:25px;padding-right:4px}div.icon-container{display:inline-block;width:50%;text-align:center;color:#000}"]
                    }] }
        ];
        /** @nocollapse */
        AddRowComponent.ctorParameters = function () { return []; };
        AddRowComponent.propDecorators = {
            store: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            rowadd: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }]
        };
        return AddRowComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/body/components/filter-row/filter-row.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FilterRowComponent = /** @class */ (function () {
        function FilterRowComponent(ngTreeGridService) {
            this.ngTreeGridService = ngTreeGridService;
            this.search_values = {};
        }
        /**
         * @return {?}
         */
        FilterRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns.forEach(( /**
                 * @param {?} column
                 * @return {?}
                 */function (column) {
                    _this.search_values[column.name] = '';
                }));
            };
        /**
         * @return {?}
         */
        FilterRowComponent.prototype.filter = /**
         * @return {?}
         */
            function () {
                this.store.filterBy(this.columns.map(( /**
                 * @param {?} column
                 * @return {?}
                 */function (column) { return column.name; })), Object.values(this.search_values));
                this.ngTreeGridService.expandAll(this.expand_tracker);
            };
        FilterRowComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-filter-row]',
                        template: "<td *ngIf=\"configs.multi_select\"></td>\r\n<td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\r\n<td *ngFor=\"let group_by of configs.group_by\"></td>\r\n<td *ngFor=\"let column of columns\">\r\n  <div *ngIf=\"column.filter\">\r\n    <input type=\"text\" (keyup)=\"filter()\" [(ngModel)]=\"search_values[column.name]\">\r\n  </div>\r\n</td>",
                        styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}select{padding:5px}tr.child{background:#fff}tr.parent{background:#fafbff}tr.selected{background-color:#e2e7eb}tr span.expand-icon-container{padding-right:10px;cursor:pointer}tr div.parent-container{display:inline-block}tr i.minus{border:1px solid transparent;margin-right:23px}tr i.minus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.checkbox_column{text-align:center}tr td:nth-child(1){padding:.3rem}tr td i.plus{border:1px solid transparent;margin-right:23px}tr td i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:10px;margin-left:6px}tr td i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:2px;margin-left:14px}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}.column-hide{display:none}.expand-column-table td{border:none;padding:0!important}td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.2rem}td input{width:100%;padding:.1rem;box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box}"]
                    }] }
        ];
        /** @nocollapse */
        FilterRowComponent.ctorParameters = function () {
            return [
                { type: NgtreegridService }
            ];
        };
        FilterRowComponent.propDecorators = {
            store: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }]
        };
        return FilterRowComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/body/body.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BodyModule = /** @class */ (function () {
        function BodyModule() {
        }
        BodyModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TreeBodyComponent, AddRowComponent, FilterRowComponent],
                        imports: [
                            common.CommonModule,
                            CellModule,
                            forms.FormsModule
                        ],
                        exports: [TreeBodyComponent, AddRowComponent]
                    },] }
        ];
        return BodyModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/head/components/tree-head/tree-head.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadComponent = /** @class */ (function () {
        function TreeHeadComponent() {
            this.sortcolumn = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.addRow = /**
         * @return {?}
         */
            function () {
                this.internal_configs.show_add_row = true;
            };
        /**
         * @param {?} column
         * @return {?}
         */
        TreeHeadComponent.prototype.sortColumn = /**
         * @param {?} column
         * @return {?}
         */
            function (column) {
                this.sortcolumn.emit(column);
            };
        /**
         * @param {?} e
         * @return {?}
         */
        TreeHeadComponent.prototype.selectAll = /**
         * @param {?} e
         * @return {?}
         */
            function (e) {
                if (e.target.checked) {
                    this.store.selectAll();
                    this.rowselectall.emit(e);
                }
                else {
                    this.store.deSelectAll();
                    this.rowdeselectall.emit(e);
                }
            };
        TreeHeadComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-head]',
                        template: "<tr [ngClass]=\"configs.css.header_class\">\r\n  <th *ngIf=\"configs.multi_select\" class=\"checkbox_column\"  [attr.width]=\"configs.multi_select_width\">\r\n    <input type=\"checkbox\" (click)=\"selectAll($event)\" [checked]=\"this.internal_configs.all_selected\">\r\n  </th>\r\n  <th \r\n    *ngIf=\"configs.actions.add || configs.actions.edit || configs.actions.delete\" \r\n    class=\"action-column\"\r\n    width=\"{{configs.action_column_width}}\"\r\n    (click)=\"addRow()\">\r\n    <span class=\"icon-container\">\r\n      <i *ngIf=\"!internal_configs.show_add_row && configs.actions.add\" [ngClass]=\"configs.css.add_class\" aria-hidden=\"true\" title=\"Add a row\"></i>\r\n      <span *ngIf=\"internal_configs.show_add_row || !configs.actions.add\">Actions</span>\r\n    </span>\r\n  </th>\r\n  <th class=\"clear-right-border group-by-column\" [attr.width]=\"configs.group_by_width[i]\"\r\n      *ngFor=\"let header of configs.group_by_header; let i = index\">\r\n    {{header}}\r\n  </th>\r\n  <th *ngFor=\"let column of columns\" (click)=\"sortColumn(column)\" [attr.width]=\"column.width\"\r\n    [ngClass]=\"{'sorted': column.sorted,'sortable': column.sortable, 'column-hide': column.hidden}\" >\r\n      <span>{{column.header}}</span>\r\n      <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 0?'arrow-down active':'arrow-down'\"></span>\r\n      <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 1?'arrow-up active':'arrow-up'\"></span>\r\n  </th>\r\n</tr>",
                        styles: [".db-tree-grid{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr th.action-column span.icon-container,tr th.sortable{cursor:pointer}tr th.sortable:hover span.arrow-up{border-bottom:6px solid #afafaf}tr th.sortable:hover span.arrow-down{border-top:6px solid #afafaf}tr th span.arrow-up{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-bottom:6px solid #ddd;position:relative;top:-18px;font-size:1rem}tr th span.arrow-up.active{border-bottom:6px solid #8a8989!important}tr th span.arrow-down{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:6px solid #ddd;position:relative;left:10px;top:17px;font-size:1rem}tr th span.arrow-down.active{border-top:6px solid #8a8989!important}tr th:nth-child(1){padding:.3rem}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}tr th.clear-left-border{border-left:0!important}tr th.clear-right-border{border-right:0!important}tr th.checkbox_column{text-align:center}.column-hide{display:none}svg{width:25px;padding-right:5px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeHeadComponent.ctorParameters = function () { return []; };
        TreeHeadComponent.propDecorators = {
            store: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            sortcolumn: [{ type: i0.Output }],
            rowselectall: [{ type: i0.Input }],
            rowdeselectall: [{ type: i0.Input }]
        };
        return TreeHeadComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/head/head.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HeadModule = /** @class */ (function () {
        function HeadModule() {
        }
        HeadModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TreeHeadComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [TreeHeadComponent]
                    },] }
        ];
        return HeadModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngtreegrid.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgtreegridModule = /** @class */ (function () {
        function NgtreegridModule() {
        }
        NgtreegridModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [NgtreegridComponent],
                        imports: [
                            common.CommonModule,
                            BodyModule,
                            HeadModule
                        ],
                        exports: [NgtreegridComponent]
                    },] }
        ];
        return NgtreegridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngtreegrid.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgtreegridService = NgtreegridService;
    exports.NgtreegridComponent = NgtreegridComponent;
    exports.NgtreegridModule = NgtreegridModule;
    exports.DefaultEditor = DefaultEditor;
    exports.ɵa = BodyModule;
    exports.ɵc = AddRowComponent;
    exports.ɵd = FilterRowComponent;
    exports.ɵb = TreeBodyComponent;
    exports.ɵe = CellModule;
    exports.ɵk = TreeCellActionsComponent;
    exports.ɵi = CustomCellEditorComponent;
    exports.ɵj = TreeCellEditorComponent;
    exports.ɵh = CustomCellViewComponent;
    exports.ɵg = TreeCellViewComponent;
    exports.ɵf = TreeCellComponent;
    exports.ɵm = TreeHeadComponent;
    exports.ɵl = HeadModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngtreegrid.umd.js.map